<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"><head><meta http-equiv="Content-Type" content="text/html; charset=UTF-8" /><title>Appendix A. Description of program options for the synopsis executable</title><link rel="stylesheet" href="synopsis.css" type="text/css" /><meta name="generator" content="DocBook XSL Stylesheets V1.73.2" /><link rel="start" href="index.html" title="Synopsis Tutorial" /><link rel="up" href="index.html" title="Synopsis Tutorial" /><link rel="prev" href="sxr-formatter.html" title="The SXR Formatter" /><link rel="next" href="processor-listing.html" title="Appendix B. Listing of some Processors and their parameters" /></head><body><div class="navheader"><table width="100%" summary="Navigation header"><tr><th colspan="3" align="center">Appendix A. Description of program options for the synopsis executable</th></tr><tr><td width="20%" align="left"><a accesskey="p" href="sxr-formatter.html">Prev</a> </td><th width="60%" align="center"> </th><td width="20%" align="right"> <a accesskey="n" href="processor-listing.html">Next</a></td></tr></table></div><div class="appendix" lang="en" xml:lang="en"><div class="titlepage"><div><div><h2 class="title"><a id="executable"></a>Appendix A. Description of program options for the synopsis executable</h2></div><div><h2 class="title"><a id="executable"></a>Appendix A. Description of program options for the synopsis executable</h2></div></div></div><p>The synopsis executable is a little convenience frontend
      to the larger Synopsis framework consisting of IR-related
      types as well as <span class="emphasis"><em>Processor</em></span> classes.</p><p>While the full power of synopsis is available through
      scripting (see <a class="xref" href="scripting.html" title="Chapter 3. Scripting And Extending Synopsis">Chapter 3, <i>Scripting And Extending Synopsis</i></a>), it is possible
      to quickly generate simple documentation by means of an
      easy-to-use executable, that is nothing more but a little
      script with some extra command line argument parsing.</p><p>This tool has three processor types it can call:</p><div class="variablelist"><dl><dt><span class="term">Parser</span></dt><dd><p>A processor that will parse source code into an
            internal abstract semantic graph (ASG). Various Parsers
            have a variety of parameters to control how exactly
            they do that.</p></dd><dt><span class="term">Linker</span></dt><dd><p>A processor that will remove duplicate symbols,
            forward declarations, and apply any number of ASG
            manipulations you want. The user typically specifies
            what sub-processors to load to run from the linker.</p></dd><dt><span class="term">Formatter</span></dt><dd><p>A processor that generates some form of formatted
            output from an existing ASG, typically html, docbook xml,
            or class graphs. Other formatters exist to assist debugging,
            such as a <span class="type">List</span> formatter that prints specific
            aspects of the IR to stdout, or a <span class="type">Dump</span> formatter
            that writes the IR to an xml file, useful for unit testing.</p></dd></dl></div><p>You can run synopsis with a single processor, for example
      to parse a C++ file <code class="filename">source.hh</code> and store 
      the ASG into a file <code class="filename">source.syn</code>, or you can
      combine it directly with linker and or formatter to generate
      the output you want in a single call.</p><p>While the document generation in a single call is convenient,
      for larger projects it is much more sensible to integrate the
      document generation into existing build systems and let the build
      system itself manage the dependencies between the intermediate files
      and the source files.</p><p>For example, a typical Makefile fragment that contains the rules
      to generate documentation out of multiple source files may look like
      this:</p><pre class="programlisting">
      hdr := $(wildcard *.h)
      syn := $(patsubst %.h, %.syn, $(hdr))

      html: $(syn)
          synopsis -f HTML -o $@ $&lt;

      %.syn: %.h
          synopsis -p Cxx -I../include -o $@ $&lt;
    </pre><p>Here is a listing of the most important available options:</p><div class="variablelist"><dl><dt><span class="term">-h, </span><span class="term">--help</span></dt><dd><p>print out help message</p></dd><dt><span class="term">-V, </span><span class="term">--version</span></dt><dd><p>print out version info and exit</p></dd><dt><span class="term">-v, </span><span class="term">--verbose</span></dt><dd><p>operate verbosely</p></dd><dt><span class="term">-d, </span><span class="term">--debug</span></dt><dd><p>operate in debug mode</p></dd><dt><span class="term">-o, </span><span class="term">--output</span></dt><dd><p>output file / directory</p></dd><dt><span class="term">-p, </span><span class="term">--parser</span></dt><dd><p>select a parser</p></dd><dt><span class="term">-l, </span><span class="term">--link</span></dt><dd><p>link</p></dd><dt><span class="term">-f, </span><span class="term">--formatter</span></dt><dd><p>select a formatter</p></dd><dt><span class="term">-I</span></dt><dd><p>set an include search path</p></dd><dt><span class="term">-D</span></dt><dd><p>specify a macro for the parser</p></dd><dt><span class="term">-W</span></dt><dd><p>pass down additional arguments to a processor.
            For example '-Wp,-I.' sends the '-I.' option to the
            parser.</p></dd><dt><span class="term">--cfilter</span></dt><dd><p>Specify a comment filter (See <a class="xref" href="comment-processors.html#comment-filters" title="Comment Filters">the section called “Comment Filters”</a>).</p></dd><dt><span class="term">--translate</span></dt><dd><p>Translate comments to doc-strings, using the given markup specifier (See <a class="xref" href="comment-processors.html#comment-translators" title="Comment Translators">the section called “Comment Translators”</a>).</p></dd><dt><span class="term">--sxr-prefix</span></dt><dd><p>Specify the directory under which to store SXR info for the parsed source files.
            This causes parsers to generate SXR info, the linker to generate an sxr Symbol Table,
            and for the HTML formatter this causes Source and XRef views to be generated.</p></dd><dt><span class="term">--probe</span></dt><dd><p>This is useful in conjunction with the <code class="option">-p Cpp</code> option to probe
            for system header search paths and system macro definitions. (See <a class="xref" href="compiler-emulation.html" title="Emulating A Compiler">the section called “Emulating A Compiler”</a>).</p></dd></dl></div></div><div class="navfooter"><table width="100%" summary="Navigation footer"><tr><td width="40%" align="left"><a accesskey="p" href="sxr-formatter.html">Prev</a> </td><td width="20%" align="center"> </td><td width="40%" align="right"> <a accesskey="n" href="processor-listing.html">Next</a></td></tr><tr><td width="40%" align="left" valign="top">The SXR Formatter </td><td width="20%" align="center"><a accesskey="h" href="index.html">Home</a></td><td width="40%" align="right" valign="top"> Appendix B. Listing of some Processors and their parameters</td></tr></table></div></body></html>
